(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     22528,        568]
NotebookOptionsPosition[     21307,        523]
NotebookOutlinePosition[     21650,        538]
CellTagsIndexPosition[     21607,        535]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["One-loop off-shell massless vertex ", "Title",
 CellChangeTimes->{{3.554301465671934*^9, 3.5543014667206793`*^9}, {
  3.5563005990081844`*^9, 3.5563006152061844`*^9}, {3.5583320298659925`*^9, 
  3.5583320564951925`*^9}, {3.558332146319992*^9, 3.558332170593592*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {AbsoluteThickness[1], Dashing[{Medium, Medium}], StrokeForm[{RGBColor[
    0., 0., 0.], Opacity[1.]}], EdgeForm[{RGBColor[0., 0., 0.], Opacity[1.]}],
     EdgeForm[None], 
    LineBox[{{0.3055555555555556, 0.8138888888888891}, {0.9388888888888891, 
     0.5000000000000002}}]}, 
   {AbsoluteThickness[1], Dashing[{Medium, Medium}], StrokeForm[{RGBColor[
    0., 0., 0.], Opacity[1.]}], EdgeForm[{RGBColor[0., 0., 0.], Opacity[1.]}],
     EdgeForm[None], 
    LineBox[{{0.9388888888888891, 0.5000000000000001}, {0.3055555555555557, 
     0.17500000000000016`}}]}, 
   {AbsoluteThickness[1], Dashing[{Medium, Medium}], StrokeForm[{RGBColor[
    0., 0., 0.], Opacity[1.]}], EdgeForm[{RGBColor[0., 0., 0.], Opacity[1.]}],
     EdgeForm[None], 
    LineBox[{{0.3055555555555556, 0.8138888888888892}, {0.3055555555555556, 
     0.17500000000000038`}}]}, 
   {AbsoluteThickness[3], StrokeForm[{RGBColor[0., 0., 0.], Opacity[1.]}], 
    EdgeForm[{RGBColor[0., 0., 0.], Opacity[1.]}], EdgeForm[None], 
    LineBox[{{0.3055555555555556, 0.8138888888888892}, {0.16666666666666666`, 
     0.8888888888888892}}]}, 
   {AbsoluteThickness[3], StrokeForm[{RGBColor[0., 0., 0.], Opacity[1.]}], 
    EdgeForm[{RGBColor[0., 0., 0.], Opacity[1.]}], EdgeForm[None], 
    LineBox[{{0.3055555555555556, 0.17500000000000027`}, {
     0.16666666666666663`, 0.10000000000000031`}}]}, 
   {AbsoluteThickness[3], StrokeForm[{RGBColor[0., 0., 0.], Opacity[1.]}], 
    EdgeForm[{RGBColor[0., 0., 0.], Opacity[1.]}], EdgeForm[None], 
    LineBox[{{0.9388888888888891, 0.5000000000000001}, {1.091666666666667, 
     0.5000000000000001}}]}, InsetBox[
    StyleBox[
     TagBox["p",
      HoldForm],
     TextAlignment->Center,
     Magnification->1.6000001430511475`,
     Background->GrayLevel[1.]], {0.21621621621621634`, 0.9124124124124123}, {
    Left, Baseline},
    Alignment->{Left, Top}], InsetBox[
    StyleBox[
     TagBox["q",
      HoldForm],
     TextAlignment->Center,
     Magnification->1.6000001430511475`,
     Background->GrayLevel[
      1.]], {0.19619619619619633`, 0.05955955955955927}, {Left, Baseline},
    Alignment->{Left, Top}], {
    StyleBox[InsetBox[
      StyleBox[
       TagBox["",
        HoldForm],
       Background->GrayLevel[1.]], {0.2922922922922924, 0.4999999999999998}, {
      Left, Baseline},
      Alignment->{Left, Top}],
     FontSize->12], 
    StyleBox[
     InsetBox["1", {0.33233232960482134`, 0.48169601949149243`}, {
      Left, Baseline}, {0.020020020020020023`, 0.04804804804804804}, {{1., 
      0.}, {0., 1.}},
      Alignment->{Left, Top}],
     FontSize->12], 
    StyleBox[InsetBox[
      StyleBox[
       TagBox["2",
        HoldForm],
       Background->GrayLevel[1.]], {0.568568568568569, 0.6281281281281275}, {
      Left, Baseline},
      Alignment->{Left, Top}],
     FontSize->12], 
    StyleBox[InsetBox[
      StyleBox[
       TagBox["3",
        HoldForm],
       Background->GrayLevel[1.]], {0.5785785785785791, 0.3398398398398388}, {
      Left, Baseline},
      Alignment->{Left, Top}],
     FontSize->12]}},
  ContentSelectable->True,
  ImagePadding->{{0., 0.}, {0., 0.}},
  ImageSize->{333., 256.},
  PlotRange->{{0., 1.3333333333333335`}, {0., 1.}},
  PlotRangePadding->Automatic]], "Text",
 CellChangeTimes->{{3.5590376934758*^9, 3.559037983823*^9}, {
  3.56255836715816*^9, 3.562558395761796*^9}}],

Cell[CellGroupData[{

Cell["Finding reduction rules and saving", "Section",
 CellChangeTimes->{{3.5563006288211846`*^9, 3.5563006412801847`*^9}, 
   3.5563047894731846`*^9, {3.5563874491311193`*^9, 3.5563874694263287`*^9}, {
   3.556387654361615*^9, 3.556387654580011*^9}, {3.558087740996797*^9, 
   3.5580877504503975`*^9}, {3.5581923266977777`*^9, 3.5581923395365777`*^9}, 
   3.558332181092392*^9}],

Cell[CellGroupData[{

Cell["Initialization", "Subsubsection",
 CellChangeTimes->{{3.558239452032984*^9, 3.558239460051384*^9}, {
  3.5594474241680555`*^9, 3.5594474249991035`*^9}, {3.5642224638962*^9, 
  3.5642224649882*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"<<", "LiteRed`"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"Loading", " ", "the", " ", "package"}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"SetDirectory", "[", 
    RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";"}], "\n", 
  RowBox[{"(*", 
   RowBox[{"Setting", " ", "working", " ", "directory"}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"SetDim", "[", "d", "]"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
   "d", " ", "stands", " ", "for", " ", "the", " ", "dimensionality"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Declare", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"l", ",", "p", ",", "q"}], "}"}], ",", "Vector"}], "]"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"vector", " ", "variables"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.556387476025002*^9, 3.556387500110939*^9}, {
   3.55638765826154*^9, 3.556387681567492*^9}, 3.5563877956979647`*^9, 
   3.5563878376330256`*^9, {3.556393461976188*^9, 3.556393465660188*^9}, {
   3.556477464449*^9, 3.5564774810950003`*^9}, 3.5578233405741854`*^9, {
   3.5580870050049973`*^9, 3.558087007329397*^9}, {3.558087767703997*^9, 
   3.558087821336797*^9}, {3.558087906637597*^9, 3.558087931754597*^9}, {
   3.558087970882397*^9, 3.5580879710071974`*^9}, {3.558098647982397*^9, 
   3.558098695065197*^9}, {3.558098864973997*^9, 3.558098865613597*^9}, 
   3.5581007315683975`*^9, 3.5581007714635973`*^9, {3.558191215525778*^9, 
   3.5581912467881775`*^9}, {3.5581919269231777`*^9, 
   3.5581919289355774`*^9}, {3.5581923725773773`*^9, 3.558192373560178*^9}, {
   3.5581924527467775`*^9, 3.5581924555079775`*^9}, {3.5583279855806*^9, 
   3.5583280165976*^9}, {3.558452223451192*^9, 3.5584522665261917`*^9}, {
   3.558452384097192*^9, 3.5584524090081916`*^9}, {3.5641028382512455`*^9, 
   3.5641028392496476`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Defining the basis, searching for the symmetries & reduction rules\
\>", "Subsubsection",
 CellChangeTimes->{{3.558239452032984*^9, 3.558239495198184*^9}, {
  3.5583280531406*^9, 3.5583280681336*^9}, {3.5594472325120935`*^9, 
  3.559447233361142*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"NewBasis", "[", 
   RowBox[{"v1", ",", 
    RowBox[{"{", 
     RowBox[{"l", ",", 
      RowBox[{"p", "-", "l"}], ",", 
      RowBox[{"q", "+", "l"}]}], "}"}], ",", 
    RowBox[{"{", "l", "}"}], ",", 
    RowBox[{"Directory", "\[Rule]", "\"\<v1 dir\>\""}]}], "]"}], "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Basis", " ", 
     RowBox[{"definition", ".", " ", "A"}], " ", "vector", " ", "in", " ", 
     "the", " ", "second", " ", "argument", " ", "is", " ", "a", " ", 
     "shortcut", " ", "for", " ", "massles", " ", "propagator"}], ",", " ", 
    RowBox[{
     RowBox[{"e", ".", "g", ".", " ", "p"}], "-", 
     RowBox[{"l", " ", "shortcuts", " ", 
      RowBox[{"sp", "[", 
       RowBox[{
        RowBox[{"p", "-", "l"}], ",", 
        RowBox[{"p", "-", "l"}]}], "]"}]}]}], ",", " ", 
    RowBox[{
    "third", " ", "option", " ", "is", " ", "the", " ", "directory", " ", 
     "where", " ", "all", " ", "definitions", " ", "for", " ", "the", " ", 
     "basis", " ", "are", " ", "saved"}]}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"GenerateIBP", "[", "v1", "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"IBP", " ", 
     RowBox[{"generation", ".", " ", "Can"}], " ", "be", " ", "also", " ", 
     "invoked", " ", "by", " ", "passing", " ", "GenerateIBP"}], "\[Rule]", 
    RowBox[{
    "True", " ", "option", " ", "in", " ", "NewBasis", " ", "call"}]}], 
   "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"AnalyzeSectors", "[", "v1", "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Zero", " ", "and", " ", "simple", " ", "sectors", " ", 
     RowBox[{"determination", ".", " ", "Can"}], " ", "be", " ", "also", " ", 
     "invoked", " ", "by", " ", "passing", " ", "AnalyzeSectors"}], "\[Rule]", 
    RowBox[{"True", " ", "option", " ", "in", " ", "NewBasis", " ", 
     RowBox[{"call", "."}]}]}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"FindSymmetries", "[", "v1", "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Finding", " ", "unique", " ", "and", " ", "mapped", " ", 
     RowBox[{"sectors", ".", " ", "Can"}], " ", "be", " ", "also", " ", 
     "invoked", " ", "by", " ", "passing", " ", "FindSymmetries"}], "\[Rule]", 
    RowBox[{"True", " ", "option", " ", "in", " ", "NewBasis", " ", 
     RowBox[{"call", "."}]}]}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.556387476025002*^9, 3.556387500110939*^9}, {
   3.55638765826154*^9, 3.556387681567492*^9}, 3.5563877956979647`*^9, 
   3.5563878376330256`*^9, {3.556393461976188*^9, 3.556393465660188*^9}, {
   3.556477464449*^9, 3.5564774810950003`*^9}, 3.5578233405741854`*^9, {
   3.5580870050049973`*^9, 3.558087007329397*^9}, {3.558087767703997*^9, 
   3.558087821336797*^9}, {3.558087906637597*^9, 3.558087931754597*^9}, {
   3.558087970882397*^9, 3.5580879710071974`*^9}, {3.558098647982397*^9, 
   3.558098695065197*^9}, {3.558098864973997*^9, 3.558098865613597*^9}, 
   3.5581007315683975`*^9, 3.5581007714635973`*^9, {3.558191215525778*^9, 
   3.5581912467881775`*^9}, {3.5581919269231777`*^9, 
   3.5581919289355774`*^9}, {3.5581923725773773`*^9, 3.558192373560178*^9}, {
   3.5581924527467775`*^9, 3.5581924555079775`*^9}, {3.5583279855806*^9, 
   3.5583280165976*^9}, {3.5583280836226*^9, 3.5583282271776*^9}, {
   3.5583282663126*^9, 3.5583282851605997`*^9}, {3.5583283375156*^9, 
   3.5583283378466*^9}, 3.558455034215192*^9, {3.559437682918888*^9, 
   3.559437683217905*^9}, 3.5594378685995083`*^9, {3.5641027014702053`*^9, 
   3.5641027485666885`*^9}, 3.5641027798915434`*^9}],

Cell[BoxData[
 RowBox[{"SolvejSector", "/@", 
  RowBox[{"UniqueSectors", "[", "v1", "]"}], 
  RowBox[{"(*", 
   RowBox[{
   "Solving", " ", "IBP", " ", "identities", " ", "for", " ", "unique", " ", 
    RowBox[{"sectors", "."}]}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.556387476025002*^9, 3.556387500110939*^9}, {
   3.55638765826154*^9, 3.556387681567492*^9}, 3.5563877956979647`*^9, 
   3.5563878376330256`*^9, {3.556393461976188*^9, 3.556393465660188*^9}, {
   3.556477464449*^9, 3.5564774810950003`*^9}, 3.5578233405741854`*^9, {
   3.5580870050049973`*^9, 3.558087007329397*^9}, {3.558087767703997*^9, 
   3.558087821336797*^9}, {3.558087906637597*^9, 3.558087931754597*^9}, {
   3.558087970882397*^9, 3.5580879710071974`*^9}, {3.558098647982397*^9, 
   3.558098695065197*^9}, {3.558098864973997*^9, 3.558098865613597*^9}, 
   3.5581007315683975`*^9, 3.5581007714635973`*^9, {3.558191215525778*^9, 
   3.5581912467881775`*^9}, {3.5581919269231777`*^9, 
   3.5581919289355774`*^9}, {3.5581923725773773`*^9, 3.558192373560178*^9}, {
   3.5581924527467775`*^9, 3.5581924555079775`*^9}, {3.5583279855806*^9, 
   3.5583280165976*^9}, {3.5583280836226*^9, 3.5583282271776*^9}, {
   3.5583282663126*^9, 3.5583282851605997`*^9}, {3.5583283375156*^9, 
   3.5583283378466*^9}, 3.558455034215192*^9, {3.559437682918888*^9, 
   3.559437683217905*^9}, {3.5594378685995083`*^9, 3.559437898463217*^9}, {
   3.5641027874887567`*^9, 3.564102809016794*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DiskSave", "[", "v1", "]"}], 
  RowBox[{"(*", 
   RowBox[{"Saving", " ", "to", " ", "default", " ", 
    RowBox[{"directory", "."}]}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"Quit", "[", "]"}], 
  RowBox[{"(*", 
   RowBox[{"Quitting", " ", "the", " ", "kernel"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.556387476025002*^9, 3.556387500110939*^9}, {
   3.55638765826154*^9, 3.556387681567492*^9}, 3.5563877956979647`*^9, 
   3.5563878376330256`*^9, {3.556393461976188*^9, 3.556393465660188*^9}, {
   3.556477464449*^9, 3.5564774810950003`*^9}, 3.5578233405741854`*^9, {
   3.5580870050049973`*^9, 3.558087007329397*^9}, {3.558087767703997*^9, 
   3.558087821336797*^9}, {3.558087906637597*^9, 3.558087931754597*^9}, {
   3.558087970882397*^9, 3.5580879710071974`*^9}, {3.558098647982397*^9, 
   3.558098695065197*^9}, {3.558098864973997*^9, 3.558098865613597*^9}, 
   3.5581007315683975`*^9, 3.5581007714635973`*^9, {3.558191215525778*^9, 
   3.5581912467881775`*^9}, {3.5581919269231777`*^9, 
   3.5581919289355774`*^9}, {3.5581923725773773`*^9, 3.558192373560178*^9}, {
   3.5581924527467775`*^9, 3.5581924555079775`*^9}, {3.5583279855806*^9, 
   3.5583280165976*^9}, {3.5583280836226*^9, 3.5583282271776*^9}, {
   3.5583282663126*^9, 3.5583282851605997`*^9}, {3.5583283375156*^9, 
   3.5583283378466*^9}, 3.558455034215192*^9, {3.559437682918888*^9, 
   3.559437683217905*^9}, {3.5594378685995083`*^9, 3.559437898463217*^9}, {
   3.5625580999808784`*^9, 3.562558100108886*^9}, {3.564102814960405*^9, 
   3.564102820592015*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Loading the basis and reducing", "Section",
 CellChangeTimes->{{3.5563006288211846`*^9, 3.5563006412801847`*^9}, 
   3.5563047894731846`*^9, {3.5563874491311193`*^9, 3.5563874694263287`*^9}, {
   3.556387654361615*^9, 3.556387654580011*^9}, {3.558087740996797*^9, 
   3.5580877504503975`*^9}, {3.5581923266977777`*^9, 3.5581923691453776`*^9}, 
   3.5581925468961773`*^9}],

Cell[CellGroupData[{

Cell["Initialization", "Subsubsection",
 CellChangeTimes->{{3.5583283562586*^9, 3.5583283594616003`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"<<", "LiteRed`"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"Loading", " ", "the", " ", "package"}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"SetDirectory", "[", 
    RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";"}], "\n", 
  RowBox[{"(*", 
   RowBox[{"Setting", " ", "working", " ", "directory"}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"SetDim", "[", "d", "]"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
   "d", " ", "stands", " ", "for", " ", "the", " ", "dimensionality"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Declare", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"l", ",", "p", ",", "q"}], "}"}], ",", "Vector"}], "]"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"vector", " ", "variables"}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"<<", "\"\<v1 dir/v1\>\""}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"Load", " ", "the", " ", "basis"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.556387476025002*^9, 3.556387500110939*^9}, {
   3.55638765826154*^9, 3.556387681567492*^9}, 3.5563877956979647`*^9, 
   3.5563878376330256`*^9, {3.556393461976188*^9, 3.556393465660188*^9}, {
   3.556477464449*^9, 3.5564774810950003`*^9}, 3.5578233405741854`*^9, {
   3.5580870050049973`*^9, 3.558087007329397*^9}, {3.558087767703997*^9, 
   3.558087821336797*^9}, {3.558087906637597*^9, 3.558087931754597*^9}, {
   3.558087970882397*^9, 3.5580879710071974`*^9}, {3.558098647982397*^9, 
   3.558098695065197*^9}, {3.558098864973997*^9, 3.558098865613597*^9}, 
   3.5581007315683975`*^9, 3.5581007714635973`*^9, {3.558191215525778*^9, 
   3.5581912467881775`*^9}, {3.5581919269231777`*^9, 
   3.5581919289355774`*^9}, {3.5581923725773773`*^9, 3.558192373560178*^9}, {
   3.5581924527467775`*^9, 3.5581924555079775`*^9}, {3.5583279855806*^9, 
   3.5583280165976*^9}, {3.5583283297986*^9, 3.5583283341256*^9}, {
   3.558452496378192*^9, 3.5584525239151917`*^9}, {3.5584550278831916`*^9, 
   3.558455030821192*^9}, {3.5586775956581182`*^9, 3.5586775960081377`*^9}, {
   3.5594376897302775`*^9, 3.559437689977292*^9}, {3.5641028689364996`*^9, 
   3.5641028701533017`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Reduction", "Subsubsection",
 CellChangeTimes->{{3.5583284278436003`*^9, 3.5583284325516*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"IBPReduce", "[", 
   RowBox[{
    RowBox[{"j", "[", 
     RowBox[{"v1", ",", "1", ",", "2", ",", "3"}], "]"}], "+", 
    RowBox[{"j", "[", 
     RowBox[{"v1", ",", "3", ",", "2", ",", "1"}], "]"}]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
   "reduction", " ", "of", " ", "the", " ", "general", " ", "linear", " ", 
    "combination", " ", "of", " ", 
    RowBox[{"j", "[", "\[Ellipsis]", "]"}]}], "*)"}]}]], "Input",
 CellChangeTimes->{
  3.5581913157285776`*^9, {3.5581913499413776`*^9, 3.558191350690178*^9}, 
   3.5581924968177776`*^9, {3.5583283042816*^9, 3.5583283090176*^9}, {
   3.5583283692995996`*^9, 3.5583284177096*^9}}],

Cell[TextData[{
 "Differentiation: Dinv[j[v1,1,1,1],sp[p,q]]  stands for ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FractionBox["\[PartialD]", 
     RowBox[{"\[PartialD]", 
      RowBox[{"(", 
       RowBox[{"p", "\[CenterDot]", "q"}], ")"}]}]], 
    RowBox[{"j", "[", 
     RowBox[{"v1", ",", "1", ",", "1", ",", "1"}], "]"}]}], TraditionalForm]]]
}], "Text",
 CellChangeTimes->{{3.5581925560065775`*^9, 3.5581925680029774`*^9}, {
  3.5583284628136*^9, 3.5583285012636003`*^9}}],

Cell[BoxData[
 RowBox[{"Collectj", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"IBPReduce", "[", 
     RowBox[{"Dinv", "[", 
      RowBox[{
       RowBox[{"j", "[", 
        RowBox[{"v1", ",", "1", ",", "1", ",", "1"}], "]"}], ",", 
       RowBox[{"p", "\[CenterDot]", "q"}]}], "]"}], "]"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"p", "\[CenterDot]", "p"}], "\[Rule]", 
       SuperscriptBox[
        SubscriptBox["m", "1"], "2"]}], ",", 
      RowBox[{
       RowBox[{"q", "\[CenterDot]", "q"}], "\[Rule]", 
       SuperscriptBox[
        SubscriptBox["m", "2"], "2"]}], ",", 
      RowBox[{
       RowBox[{"p", "\[CenterDot]", "q"}], "\[Rule]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           SubscriptBox["m", "3"], "2"], "-", 
          SuperscriptBox[
           SubscriptBox["m", "1"], "2"], "-", 
          SuperscriptBox[
           SubscriptBox["m", "2"], "2"]}], ")"}], "/", "2"}]}]}], "}"}]}], 
   ",", "Factor"}], "]"}]], "Input",
 CellChangeTimes->{{3.5581925710449777`*^9, 3.5581925920747776`*^9}, {
  3.5581927443043776`*^9, 3.558192819995578*^9}, {3.5594474858135815`*^9, 
  3.559447486118599*^9}}],

Cell["\<\
Dimensional Recurrences.
 LoweringDRR[v1,1,1,1] (RaisingDRR[v1,1,1,1]) gives the right-hand side of \
the lowering (raising) recurrence relation for j[v1,1,1,1]\
\>", "Text",
 CellChangeTimes->{{3.5581925560065775`*^9, 3.5581925680029774`*^9}, {
  3.5581926037445774`*^9, 3.5581926133385773`*^9}, {3.5583286573115997`*^9, 
  3.5583287018226*^9}, {3.5583289543966*^9, 3.5583289874066*^9}}],

Cell[BoxData[
 RowBox[{"Collectj", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"IBPReduce", "[", 
     RowBox[{"LoweringDRR", "[", 
      RowBox[{"v1", ",", "1", ",", "1", ",", "1"}], "]"}], "]"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"p", "\[CenterDot]", "p"}], "\[Rule]", 
       SuperscriptBox[
        SubscriptBox["m", "1"], "2"]}], ",", 
      RowBox[{
       RowBox[{"q", "\[CenterDot]", "q"}], "\[Rule]", 
       SuperscriptBox[
        SubscriptBox["m", "2"], "2"]}], ",", 
      RowBox[{
       RowBox[{"p", "\[CenterDot]", "q"}], "\[Rule]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           SubscriptBox["m", "3"], "2"], "-", 
          SuperscriptBox[
           SubscriptBox["m", "1"], "2"], "-", 
          SuperscriptBox[
           SubscriptBox["m", "2"], "2"]}], ")"}], "/", "2"}]}]}], "}"}]}], 
   ",", "Factor"}], "]"}]], "Input",
 CellChangeTimes->{{3.5581925710449777`*^9, 3.5581926585803776`*^9}, {
   3.559447625385565*^9, 3.559447629547803*^9}, 3.5594477026099815`*^9}],

Cell[BoxData[
 RowBox[{"Collectj", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"IBPReduce", "[", 
     RowBox[{"RaisingDRR", "[", 
      RowBox[{"v1", ",", "1", ",", "1", ",", "1"}], "]"}], "]"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"p", "\[CenterDot]", "p"}], "\[Rule]", 
       SuperscriptBox[
        SubscriptBox["m", "1"], "2"]}], ",", 
      RowBox[{
       RowBox[{"q", "\[CenterDot]", "q"}], "\[Rule]", 
       SuperscriptBox[
        SubscriptBox["m", "2"], "2"]}], ",", 
      RowBox[{
       RowBox[{"p", "\[CenterDot]", "q"}], "\[Rule]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           SubscriptBox["m", "3"], "2"], "-", 
          SuperscriptBox[
           SubscriptBox["m", "1"], "2"], "-", 
          SuperscriptBox[
           SubscriptBox["m", "2"], "2"]}], ")"}], "/", "2"}]}]}], "}"}]}], 
   ",", "Factor"}], "]"}]], "Input",
 CellChangeTimes->{{3.5581927008729773`*^9, 3.5581927024953775`*^9}, {
   3.5594476343240757`*^9, 3.559447639059347*^9}, 3.5594477145806665`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{707, 549},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 272, 3, 83, "Title"],
Cell[854, 27, 3374, 81, 270, "Text"],
Cell[CellGroupData[{
Cell[4253, 112, 379, 5, 71, "Section"],
Cell[CellGroupData[{
Cell[4657, 121, 203, 3, 27, "Subsubsection"],
Cell[4863, 126, 1860, 41, 132, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6760, 172, 261, 5, 27, "Subsubsection"],
Cell[7024, 179, 3487, 71, 132, "Input"],
Cell[10514, 252, 1448, 23, 31, "Input"],
Cell[11965, 277, 1566, 27, 52, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[13580, 310, 377, 5, 71, "Section"],
Cell[CellGroupData[{
Cell[13982, 319, 105, 1, 27, "Subsubsection"],
Cell[14090, 322, 2158, 48, 152, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16285, 375, 100, 1, 27, "Subsubsection"],
Cell[16388, 378, 664, 16, 52, "Input"],
Cell[17055, 396, 481, 13, 40, "Text"],
Cell[17539, 411, 1188, 34, 55, "Input"],
Cell[18730, 447, 398, 7, 65, "Text"],
Cell[19131, 456, 1066, 30, 55, "Input"],
Cell[20200, 488, 1067, 30, 55, "Input"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

